<template>
  <section class="section">
    <h2 class="text-center my-4">
      Data Filtering
    </h2>

    <p class="my-8">
      This platform allows us to work on voting data. This data is compound of:
      <ol>
        <li>a collection of ballots featuring all ballots characterized by several descriptive attributes (e.g. date, topic…)</li> and <li>a collection of voters which are also characterized by several descriptive attributes (e.g. name, party…).</li>
      </ol>
      <br>
      This first step consists in selecting two <em class="keyword">study
        groups</em> of voters (A and B) which will be confronted by the mining
      algorithm in order to highlight potentially significant change of
      agreement between voters of <em class="keyword">Study Group A</em> in one
      side and voters of <em class="keyword">Study Group B</em> in the other
      side.
    </p>

    <div class="my-4">
      <GroupWithRules
        v-model="contexts_scope"
        class="box p-4"
        :rows="contextData"
        :columns="contextTableColumns"
        :dimensions="contextColumns"
      >
        <em class="keyword">Contexts search perimeter</em> (ballots)
      </GroupWithRules>
    </div>

    <div class="flex flex-col md:flex-row my-4">
      <GroupWithRules
        v-model="individuals_1_scope"
        class="box md:w-2/5 p-4"
        :rows="userData"
        :columns="userTableColumns"
        :dimensions="userColumns"
      >
        <em class="keyword">Study Group</em> A

        <button
          class="btn mx-auto mt-2"
          @click="copyRulesToA"
        >
          <icon
            class="mr-1"
            name="clone"
          />
          Copy from B
        </button>
      </GroupWithRules>

      <div class="flex flex-col flex-grow justify-center m-4">
        <div class="text-center">
          I am looking for
        </div>

        <div class="text-center my-2 text-xl">
          <toggle-button
            v-model="toggleDissentButton"
            :sync="true"
            :width="100"
            :labels="{ checked: 'conflictual', unchecked: 'consensual' }"
            :color="{ checked: '#e3342f', unchecked: '#1f9d55' }"
          />
          contexts
        </div>

        <p class="text-center">
          between those two groups, with a
        </p>

        <p class="text-center">
          <span class="text-xl">
            minimum agreement change
          </span>
          of
          <b class="text-xl">
            {{ threshold_quality | percentage }}
          </b>
        </p>

        <div class="text-center">
          <input
            v-model.number="threshold_quality"
            class="w-full"
            type="range"
            placeholder="Threshold over the quality measure"
            step="0.01"
            min="0"
            max="1"
          >
          <div class="flex justify-between text-xs">
            <p class="text-left">
              less intense change
            </p>
            <p class="text-right">
              more intense change
            </p>
          </div>
        </div>
      </div>

      <GroupWithRules
        v-model="individuals_2_scope"
        class="box md:w-2/5 p-4"
        :rows="userData"
        :columns="userTableColumns"
        :dimensions="userColumns"
      >
        <em class="keyword">Study Group</em> B

        <button
          class="btn mx-auto mt-2"
          @click="copyRulesToB"
        >
          <icon
            class="mr-1"
            name="clone"
          />
          Copy from A
        </button>
      </GroupWithRules>
    </div>

    <hr class="border-b my-8">

    <div class="my-8">
      <h2 class="text-center">
        Analysis Dimensions
      </h2>

      <p class="my-4">
        To enable the discovery of interprettable patterns, the platform offers
        the possibility to the user to choose which dimensions worth to be
        considered to highlight conflictual/consensual (depending on the desired
        query in the first step) situations in the votes.
      </p>
      <p class="my-4">
        In a nutshell, the left box allows to determine what are the dimensions
        that may appear to describe a conflictual/consensual
        situation <em class="keyword">context</em> (characterizing a subset of
        ballots), and the right box offer the possibility to determine the
        dimensions that may appear to describe a subset of voters considering
        exclusively the two <em class="keyword">study groups</em> in the first
        step (Data Filtering).
      </p>

      <p class="italic text-center my-4">
        Drop the attributes in the boxes to use them.
      </p>

      <div class="lg:grid-half">
        <div class="box bg-white p-4 w-full mb-4 lg:mb-0">
          <h5 class="text-center mb-4">
            Selected dimensions for ballots
          </h5>

          <p class="italic mb-4">
            Which dimensions to use to characterize collections of ballots?
          </p>

          <DimensionsSelector
            v-model="contextSelectedColumns"
            group="context"
            :selectable-items="dataset.selectableContextColumns"
            :img="require('@/assets/ballot_box.svg')"
            class="md:grid-half text-sm"
          />

        </div>

        <div class="box bg-white p-4 w-full">
          <h5 class="text-center mb-4">
            Selected dimensions for voters
          </h5>

          <p class="italic mb-4">
            Which dimensions to use to characterize a group of voters?
          </p>

          <DimensionsSelector
            v-model="userSelectedColumns"
            group="user"
            :selectable-items="dataset.selectableUserColumns"
            :img="require('@/assets/pawn.svg')"
            class="md:grid-half text-sm"
          />
        </div>
      </div>
    </div>

    <hr class="border-b my-8">

    <collapse
      class="box my-4"
      :open="false"
    >
      <template v-slot:toggle>
        <div
          class="p-4 cursor-pointer"
        >
          <h4 class="mb-4">
            ⚙ JSON file (Detailed Execution Properties File)
          </h4>

          <p class="italic mb-4">
            Save all the parameters in a file, or load an existing one.
          </p>

          <div
            class="flex flex-col sm:flex-row items-center"
          >
            <a
              class="btn w-full sm:w-32 mb-4 sm:mb-0 sm:mr-4 no-underline text-black"
              :href="exportSettings"
              download="settings.json"
            >
              Export
            </a>

            <label class="btn w-full sm:w-32">
              Import
              <ImportFile
                class="opacity-0 overflow-hidden absolute w-px h-px"
                @load="importSettings(JSON.parse($event))"
              />
            </label>
          </div>
        </div>
      </template>

      <div class="bg-white p-4">
        <SettingsJSON
          :json="json"
        />
      </div>
    </collapse>

    <collapse
      class="box"
      :open="false"
    >
      <template v-slot:toggle>
        <div
          class="p-4 cursor-pointer"
        >
          <h4 class="">
            ⚙ Advanced tools
          </h4>
        </div>
      </template>

      <div class="bg-white p-4">
        <div class="flex items-center my-2">
          <label class="mr-2">
            Minimum size of a collection of ballots
          </label>
          <input
            v-model.number="threshold_objects"
            class="w-16 border"
            type="number"
            placeholder="Threshold over the size of the object subgroup"
            min="1"
          >
        </div>

        <div class="flex items-center my-2">
          <label class="mr-2">
            Minimum size of a group of parliamentarians
          </label>
          <input
            v-model.number="threshold_individuals"
            type="number"
            class="border w-16"
            placeholder="Threshold over the size of the users subgroup"
            min="1"
          >
        </div>

        <div class="my-2">
          <label class="">
            Sim. Measure
          </label>
          <select
            v-model="sim_function"
            class="select"
          >
            <option
              v-for="f of sim_functions"
              :key="f.value"
              :value="f"
            >
              {{ f.label }}
            </option>
          </select>
        </div>

        <div class="my-2">
          <label class="">
            Agg. Outcome
          </label>
          <select
            v-model="agg_function"
            class="select"
          >
            <option
              v-for="f of agg_functions"
              :key="f.value"
              :value="f"
            >
              {{ f.label }}
            </option>
          </select>
        </div>
      </div>
    </collapse>
  </section>
</template>

<script lang="ts">
import { Vue, Component, Mixins, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import ToggleButton from 'vue-js-toggle-button'
import 'vue-awesome/icons/clone'
import Icon from 'vue-awesome/components/Icon.vue'

import ConfigMixin from '@/mixins/Config.ts'

import Collapse from '@/components/Collapse.vue'
import DimensionsSelector from '@/components/DimensionsSelector.vue'
import GroupWithRules from '@/components/ConfigGroupWithRules.vue'
import ImportFile from '@/components/ImportFile.vue'
import SettingsJSON from '@/components/SettingsJSON.vue'

import _ from 'lodash/fp'

Vue.use(ToggleButton)

function createJSON (vm) {
  return {
    dataset: vm.dataset,
    configType: 'inter',

    delimiter: '\t',

    nb_objects: 50000,
    nb_individuals: 50000,

    arrayHeader: vm.settings.arrayHeader,
    numericHeader: vm.settings.numericHeader,
    vector_of_outcome: null, // Fixed for now
    ponderation_attribute: null, // Fixed for now

    description_attributes_objects: vm.description_attributes_objects,
    description_attributes_individuals: vm.description_attributes_individuals,

    threshold_objects: vm.settings.threshold_objects,
    threshold_individuals: vm.settings.threshold_individuals,
    threshold_quality: vm.settings.threshold_quality,

    aggregation_measure: _.get('value', vm.agg_function),
    similarity_measure: _.get('value', vm.sim_function),
    quality_measure: _.get('value', vm.qual_function),

    algorithm: 'DSC+CLOSED+UB2', // DSC+SamplingPeers+RandomWalk
    timebudget: 3600,

    objects_scope: [],

    contexts_scope: vm.contexts_scope,
    individuals_1_scope: vm.individuals_1_scope,
    individuals_2_scope: vm.individuals_2_scope
  }
}

@Component({
  components: {
    Collapse,
    DimensionsSelector,
    GroupWithRules,
    Icon,
    ImportFile,
    SettingsJSON
  }
})
export default class ConfigInter extends Mixins(ConfigMixin) {
  showContextModal = false
  agg_functions = [
    {
      label: 'Default',
      value: 'VECTOR_VALUES'
    },
    {
      label: 'Majority Vote',
      value: 'SYMBOLIC_MAJORITY'
    },
    {
      label: 'Average of Ratings',
      value: 'AVGRATINGS_SIMPLE'
    },
    {
      label: 'Weighted Average of Ratings',
      value: 'AVGRATINGS_PONDERATION'
    },
    {
      label: 'Drugs and stuffs',
      value: 'MEDICAMENTS'
    }
  ]
  sim_functions = [
    {
      label: 'Same Majority Vote',
      value: 'MAAD'
    },
    {
      label: 'Equal Outcome',
      value: 'SAME_VOTE'
    },
    {
      label: 'Agreement Index (Cohesion Measure)',
      value: 'MAAD_AI'
    },
    {
      label: 'Same Group Behavior (COS)',
      value: 'COS'
    },
    {
      label: 'Similarity On Stars Ratings',
      value: 'AVG_YELP'
    },
    {
      label: 'Similarities between candidates',
      value: 'similarity_candidates'
    }
  ]
  qual_functions = [
    {
      label: 'Dissent',
      value: 'DISAGR_SUMDIFF'
    },
    {
      label: 'Consent',
      value: 'AGR_SUMDIFF'
    }
  ]

  get json () {
    return createJSON(this)
  }

  get toggleDissentButton () {
    return _.get('value', this.qual_function) === 'DISAGR_SUMDIFF'
  }

  set toggleDissentButton (val) {
    this.qual_function = _.find(
      _.matchesProperty(
        'value',
        val ? 'DISAGR_SUMDIFF' : 'AGR_SUMDIFF'
      ), this.qual_functions)

    const quality_measure = this.qual_function.value
    this.$store.commit('SET_SETTINGS', { quality_measure })
  }

  get sim_function () {
    return _.find(_.matchesProperty('value')(this.settings.similarity_measure), this.sim_functions)
  }

  set sim_function (sim) {
    const similarity_measure = sim.value
    this.$store.commit('SET_SETTINGS', { similarity_measure })
  }

  get agg_function () {
    return _.find(_.matchesProperty('value')(this.settings.aggregation_measure), this.agg_functions)
  }

  set agg_function (agg) {
    const aggregation_measure = agg.value
    this.$store.commit('SET_SETTINGS', { aggregation_measure })
  }

  copyRulesToA () {
    this.individuals_1_scope = _.cloneDeep(this.individuals_2_scope)
  }

  copyRulesToB () {
    this.individuals_2_scope = _.cloneDeep(this.individuals_1_scope)
  }

  get individuals_1_scope () {
    return this.settings.individuals_1_scope || []
  }

  set individuals_1_scope (individuals_1_scope: number) {
    this.$store.commit('SET_SETTINGS', { individuals_1_scope })
  }

  get individuals_2_scope () {
    return this.settings.individuals_2_scope || []
  }

  set individuals_2_scope (individuals_2_scope: number) {
    this.$store.commit('SET_SETTINGS', { individuals_2_scope })
  }
}
</script>
